<?php
/*
Admin Registration for Event Register Plugin
Based off SMF Notify Group

by pftq
Dec.28 2009

for SMF Forums 1.1.x
*/

if (!defined('SMF'))
	die('Hacking attempt...');
	
function admin_register_event() {
	global $smcFunc, $context, $scripturl, $txt;
	
	if(!allowedTo('moderate_forum')) redirectexit();
	else {
		if (empty($_REQUEST['event'])) {
			$context['page_title'] = $context['forum_name']." - ".$txt['admin_register_event'];
			
			$context['admin_register_event_boards']=array(); $context['admin_register_event_topics']=array();
			$b=$smcFunc['db_query']('', 'select b.id_board, b.name from {db_prefix}boards as b order by b.board_order');
			while($bb=$smcFunc['db_fetch_assoc']($b)) {
				$context['admin_register_event_board'][]=array('name'=>$bb['name'], 'id'=>$bb['id_board']);
				$context['admin_register_event_topics'][$bb['id_board']]=array();
				$t=$smcFunc['db_query']('', 'select id_event, title from {db_prefix}calendar where id_board={int:id_board} order by start_date DESC',
					array('id_board' => $bb['id_board'])
				);
				while($a=$smcFunc['db_fetch_assoc']($t))
					$context['admin_register_event_topics'][$bb['id_board']][]=array('title'=>$a['title'], 'id_event'=>$a['id_event']);
			}
		}
		else {
			$context['event']=(int) $_REQUEST['event'];
			if (empty($_REQUEST['sa']))
			$context['sa']='on';
			else $context['sa']=$_REQUEST['sa'];
			$context['admin_register_event_output']="";
			$context['admin_register_event_registered']=array();
			
			$msg=$smcFunc['db_fetch_assoc']($smcFunc['db_query']('',
				'select id_topic, title from {db_prefix}calendar
				where id_event={int:id_event}',
				array('id_event' => $context['event'])
			));
			
			$context['page_title'] = $context['forum_name']." - ".$txt['admin_register_event'].": ".$msg['title'];
			$context['title']=$msg['title'];
			$context['topic']=$msg['id_topic'];
			
			if(empty($_REQUEST['submit'])) $context['admin_register_event_page']=0;
			else $context['admin_register_event_page']=$_REQUEST['submit'];
			
			$temp=""; $c=0;
			
			$context['admin_register_event_output'].= "
			<script type='text/javascript'>
			function checkall(arr, namer) {
				for(var i=0;i<arr.length;i++) {
					document.getElementById(arr[i]).checked=document.getElementById(namer).checked;
				}
			}
			var check=[];";
			
			if($context['admin_register_event_page']==0) {
				$groups=$smcFunc['db_query']('',
					'select id_group, group_name from {db_prefix}membergroups
					order by group_name');
				while($g=$smcFunc['db_fetch_assoc']($groups)) {
					$temp.="<input type='checkbox' id='checkg_".$g['id_group']."' name='checkg_".$g['id_group']."' /> ".$g['group_name']." <br />";
					$context['admin_register_event_output'].= "check[".($c++)."]='checkg_".$g['id_group']."';";
				}
			}
			elseif($context['admin_register_event_page']>0) {
				$groups=$smcFunc['db_query']('',
					'select id_group, group_name from {db_prefix}membergroups');
				$memberbank=array();
				
				while($g=$smcFunc['db_fetch_assoc']($groups)) {
					if(isset($_REQUEST['checkg_'.$g['id_group']])&&$_REQUEST['checkg_'.$g['id_group']]=='on') {
						$temp.=$g['group_name'].":<br />";
						$g=$g['id_group'];
						$temp.="<input type='hidden' id='checkg_$g' name='checkg_$g' value='on' />";
				
						$members=$smcFunc['db_query']('',
							'select id_member, real_name from {db_prefix}members
							where {db_prefix}members.id_group={int:gid}
								or {db_prefix}members.id_post_group={int:gid}
								or FIND_IN_SET({int:gid}, additional_groups)
							order by {db_prefix}members.real_name',
							array('gid' => $g)
						);
						
						while($m=$smcFunc['db_fetch_assoc']($members)) {
							if(!in_array($m['id_member'], $memberbank)) {
								$temp.= "<input type='checkbox' id='checkm_".$m['id_member']."' ".($context['admin_register_event_page']==1||(isset($_REQUEST['checkm_'.$m['id_member']])&&$_REQUEST['checkm_'.$m['id_member']]=='on')? "checked='checked'":"")." name='checkm_".$m['id_member']."' /> ".$m['real_name']."<br />";
								$context['admin_register_event_output'].=  "check[".($c++)."]='checkm_".$m['id_member']."';";
								$memberbank[]=$m['id_member'];
								
								if($context['admin_register_event_page']>1&&isset($_REQUEST['checkm_'.$m['id_member']])&&$_REQUEST['checkm_'.$m['id_member']]=='on') {
									if ($context['sa']== 'on')
									{
										$check=$smcFunc['db_num_rows'](
										$smcFunc['db_query']('',
											'select ID_MEMBER from {db_prefix}calendar_reg
											where ID_MEMBER={int:id_member}
												and ID_EVENT={int:id_event}
											limit 1',
											array(
												'id_member' => $m['id_member'],
												'id_event' => $context['event']
											)
										));
										if($check==0) $smcFunc['db_query']('',
											'INSERT IGNORE INTO {db_prefix}calendar_reg (ID_MEMBER, ID_EVENT, dateRegistered, dateConfirmed, registrant)
											VALUES ({int:id_member},
												{int:id_event},
												{int:dateRegistered},
												{int:dateConfirmed},
												{string:real_name})',
											array(
												'id_member' => $m['id_member'],
												'id_event' => $context['event'],
												'dateRegistered' => time(),
												'dateConfirmed' => time(),
												'real_name' => $m['real_name']
											)
										);
									}
									elseif($context['sa']=="off")
									{
										$smcFunc['db_query']('',
											'DELETE FROM {db_prefix}calendar_reg
											WHERE ID_MEMBER = {int:id_member}
											AND ID_EVENT = {int:id_event}',
											array(
												'id_member' => $m['id_member'],
												'id_event' => $context['event']
										));
									}
								}
								
							
							}
							
						}
						
					}
				}

			}
				
			$temp.= "<input type='checkbox' id='check_all' name='check_all' ".($context['admin_register_event_page']==1? "checked='checked'":"")." onclick='checkall(check, \"check_all\");' /> ".$txt['check_all']." <br />";
			
			$context['admin_register_event_output'].= "</script>$temp";
			
			$notified=$smcFunc['db_query']('',
				'select l.ID_ENTRY, l.registrant, mem.real_name
				from {db_prefix}members as mem, {db_prefix}calendar_reg as l
				where mem.id_member=l.ID_MEMBER and l.ID_EVENT={int:id_event}
				order by mem.real_name',
				array('id_event' => $context['event'])
			);
			while($n=$smcFunc['db_fetch_assoc']($notified)) {
				if(isset($_REQUEST['del'])&&$_REQUEST['del']==$n['ID_ENTRY'])
					$smcFunc['db_query']('',
						'DELETE FROM {db_prefix}calendar_reg
						WHERE ID_ENTRY = {int:id_entry}
						LIMIT 1',
						array('id_entry' => $n['ID_ENTRY'])
					);
					
				else $context['admin_register_event_registered'][]= "<a href='?action=admin_register_event;event=".$context['event'].";sa=".$context['sa'].";del=".$n['ID_ENTRY']."'>[X]</a> ". $n['registrant']. ' / '. $n['real_name'];
			}
			
		}
	}
	
	loadTemplate('admin_register_event');
}
?>
